"""
Something relating to or practicing dermatology.

https://schema.org/Dermatologic
"""

from typing import *
from typing_extensions import TypedDict, NotRequired
from pydantic import *
from datetime import *
from time import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class DermatologicInheritedProperties(TypedDict):
    """Something relating to or practicing dermatology.

    References:
        https://schema.org/Dermatologic
    Note:
        Model Depth 6
    Attributes:
    """

    


class DermatologicProperties(TypedDict):
    """Something relating to or practicing dermatology.

    References:
        https://schema.org/Dermatologic
    Note:
        Model Depth 6
    Attributes:
    """

    


class AllProperties(DermatologicInheritedProperties , DermatologicProperties, TypedDict):
    pass


class DermatologicBaseModel(SchemaOrgBase):
    id_ : Optional[Any] = Field(default="Dermatologic",alias='@id')
    context_ : Optional[Any] = Field(default=None,alias='@context')
    graph_ : Optional[Any] = Field(default=None,alias='@graph')

    class Config:
        ...


def create_schema_org_model(type_: Union[DermatologicProperties, DermatologicInheritedProperties, AllProperties] = AllProperties) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "Dermatologic"
    return model
    

Dermatologic = create_schema_org_model()


def create_dermatologic_model(model: AllProperties):
    _type =  AllProperties.copy()
    for k in model.keys():
        if k not in _type.__annotations__:
            del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: AllProperties):
    pydantic_type =  create_dermatologic_model(model=model)
    return pydantic_type(model).schema_json()


