"""
Content about the effectiveness-related aspects of a health topic.

https://schema.org/EffectivenessHealthAspect
"""

from typing import *
from typing_extensions import TypedDict, NotRequired
from pydantic import *
from datetime import *
from time import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class EffectivenessHealthAspectInheritedProperties(TypedDict):
    """Content about the effectiveness-related aspects of a health topic.

    References:
        https://schema.org/EffectivenessHealthAspect
    Note:
        Model Depth 5
    Attributes:
    """

    


class EffectivenessHealthAspectProperties(TypedDict):
    """Content about the effectiveness-related aspects of a health topic.

    References:
        https://schema.org/EffectivenessHealthAspect
    Note:
        Model Depth 5
    Attributes:
    """

    


class AllProperties(EffectivenessHealthAspectInheritedProperties , EffectivenessHealthAspectProperties, TypedDict):
    pass


class EffectivenessHealthAspectBaseModel(SchemaOrgBase):
    id_ : Optional[Any] = Field(default="EffectivenessHealthAspect",alias='@id')
    context_ : Optional[Any] = Field(default=None,alias='@context')
    graph_ : Optional[Any] = Field(default=None,alias='@graph')

    class Config:
        ...


def create_schema_org_model(type_: Union[EffectivenessHealthAspectProperties, EffectivenessHealthAspectInheritedProperties, AllProperties] = AllProperties) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "EffectivenessHealthAspect"
    return model
    

EffectivenessHealthAspect = create_schema_org_model()


def create_effectivenesshealthaspect_model(model: AllProperties):
    _type =  AllProperties.copy()
    for k in model.keys():
        if k not in _type.__annotations__:
            del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: AllProperties):
    pydantic_type =  create_effectivenesshealthaspect_model(model=model)
    return pydantic_type(model).schema_json()


