"""
Text representing an XPath (typically but not necessarily version 1.0).

https://schema.org/XPathType
"""

from typing import *
from typing_extensions import TypedDict, NotRequired
from pydantic import *
from datetime import *
from time import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class XPathTypeInheritedProperties(TypedDict):
    """Text representing an XPath (typically but not necessarily version 1.0).

    References:
        https://schema.org/XPathType
    Note:
        Model Depth 6
    Attributes:
    """

    


class XPathTypeProperties(TypedDict):
    """Text representing an XPath (typically but not necessarily version 1.0).

    References:
        https://schema.org/XPathType
    Note:
        Model Depth 6
    Attributes:
    """

    


class AllProperties(XPathTypeInheritedProperties , XPathTypeProperties, TypedDict):
    pass


class XPathTypeBaseModel(SchemaOrgBase):
    id_ : Optional[Any] = Field(default="XPathType",alias='@id')
    context_ : Optional[Any] = Field(default=None,alias='@context')
    graph_ : Optional[Any] = Field(default=None,alias='@graph')

    class Config:
        ...


def create_schema_org_model(type_: Union[XPathTypeProperties, XPathTypeInheritedProperties, AllProperties] = AllProperties) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "XPathType"
    return model
    

XPathType = create_schema_org_model()


def create_xpathtype_model(model: AllProperties):
    _type =  AllProperties.copy()
    for k in model.keys():
        if k not in _type.__annotations__:
            del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: AllProperties):
    pydantic_type =  create_xpathtype_model(model=model)
    return pydantic_type(model).schema_json()


